<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-04-12 17:56:45
 * @LastEditors: 无尘
 * @LastEditTime: 2020-04-24 16:53:48
 -->
<template>
  <section class="common-right-wrap">
    <div class="p-20">
      <div class="flex flex-space-between m-b-20">
        <div class="flex ">
          <el-date-picker prefix-icon="el-icon-time" v-model="conditionObj.getDateRange" @change="changeDate" :editable="false" :value-format="'yyyy-MM-dd'" type="daterange" align="right" unlink-panels range-separator="~" start-placeholder="领取开始时间" end-placeholder="领取结束时间"> </el-date-picker>
          <el-date-picker class="m-l-10" prefix-icon="el-icon-time" v-model="conditionObj.useDateRange" @change="changeDate" :editable="false" :value-format="'yyyy-MM-dd'" type="daterange" align="right" unlink-panels range-separator="~" start-placeholder="核销开始时间" end-placeholder="核销结束时间"> </el-date-picker>
          <el-input placeholder="请输入卡券名称/卡券代码/会员信息" v-model="conditionObj.searchInput" class="w-264 m-l-10" style="width: 264px;" @keyup.native="value => toInput(value, conditionObj.searchInput)" clearable @clear="clearInput"> <i slot="prefix" class="el-input__icon el-icon-search"></i> </el-input>
        </div>
      </div>
      <el-table class="select-table" ref="multipleTable" :data="tableData" tooltip-effect="dark" style="width: calc(100% - 3px);">
        <el-table-column prop="" label="领取时间">
          <template slot-scope="scope">
            <div class="color-606266 line-18">{{ scope.row.sendTime | timeStampToYmd }}</div>
            <div class="color-606266 line-18">{{ scope.row.sendTime | timeStampToHms }}</div>
          </template>
        </el-table-column>
        <el-table-column prop="" label="核销时间">
          <template slot-scope="scope">
            <div class="color-606266 line-18">{{ scope.row.sendTime | timeStampToYmd }}</div>
            <div class="color-606266 line-18">{{ scope.row.sendTime | timeStampToHms }}</div>
          </template>
        </el-table-column>
        <el-table-column prop="" label="会员信息" show-overflow-tooltip>
          <template slot-scope="scope">
            <div class="flex nowrap">
              <div class="flex flex-align-center flex-pack-center bg-82C5FF table-head-pic">
                <i v-if="!scope.row.memberUrl" class="iconfont icon-yewuduanmorentouxian"></i>
                <img v-else :src="scope.row.memberUrl" alt="img" />
              </div>
              <div class="flex flex-column apply-info">
                <span class="font-14 color-606266 text-ellipsis line-18">{{ scope.row.memberName }}</span>
                <span class="font-12 color-909399 text-ellipsis line-18">{{ scope.row.memberCardNo }}</span>
              </div>
            </div>
          </template>
        </el-table-column>
        <el-table-column prop="" label="员工信息" show-overflow-tooltip>
          <template slot-scope="scope">
            <div class="flex nowrap">
              <div class="flex flex-align-center flex-pack-center bg-82C5FF table-head-pic">
                <i v-if="!scope.row.memberUrl" class="iconfont icon-yewuduanmorentouxian"></i>
                <img v-else :src="scope.row.memberUrl" alt="img" />
              </div>
              <div class="flex flex-column apply-info">
                <span class="font-14 color-606266 text-ellipsis line-18">{{ scope.row.memberName }}</span>
                <span class="font-12 color-909399 text-ellipsis line-18">{{ scope.row.memberCardNo }}</span>
              </div>
            </div>
          </template>
        </el-table-column>
        <el-table-column prop="" label="卡券类型">
          <template slot-scope="scope">
            <span v-if="scope.row.cardType == 0">抵金券</span>
            <span v-if="scope.row.cardType == 1">折扣券</span>
          </template>
        </el-table-column>
        <el-table-column prop="" label="卡券名称" show-overflow-tooltip>
          <template slot-scope="scope">
            {{ scope.row.cardName }}
          </template>
        </el-table-column>
        <el-table-column prop="" label="卡券状态" show-overflow-tooltip>
          <template slot-scope="scope">
            {{ scope.row.cardName }}
          </template>
        </el-table-column>
        <el-table-column prop="" label="投放来源" show-overflow-tooltip>
          <template slot-scope="scope">
            {{ scope.row.cardName }}
          </template>
        </el-table-column>
        <el-table-column prop="" label="核销来源" show-overflow-tooltip>
          <template slot-scope="scope">
            {{ scope.row.cardName }}
          </template>
        </el-table-column>

        <el-table-column prop="" label="操作" show-overflow-tooltip>
          <template slot-scope="scope">
            <el-button type="text" @click="toDel(scope.$index, scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block common-wrap__page text-right m-t-24" v-if="tableData.length != 0">
        <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>
      </div>
    </div>
  </section>
</template>

<script>
import errMsg from '@/common/js/error';
import showMsg from '@/common/js/showmsg';
import { _debounce } from '@/common/js/public';
import { postRequest } from '@/api/api';
export default {
  components: {},
  props: {
    brandId: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      activeId: '2',
      wxEnterpriseId: localStorage.getItem('userInfos') ? JSON.parse(localStorage.getItem('userInfos')).wxEnterpriseId : '',

      conditionObj: {
        getDateRange: [],
        useDateRange: [],
        searchInput: ''
      },
      templateList: [],
      strategyList: [],
      tableData: [],
      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0
    };
  },
  watch: {
    brandId(val) {
      if (!!val) {
        this.getTableList();
      }
    }
  },
  methods: {
    /**
     *
     */
    changeDate() {
      const that = this;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 删除
     */
    toDel(index, row) {
      const that = this;
      that
        .$confirm('是否要删除选中的卡券?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        })
        .then(() => {
          that.delCardList(row.coupCardId);
        })
        .catch(() => {});
    },
    /**
     * 删除卡券
     */
    delCardList(coupCardId) {
      const that = this;
      let para = {
        coupCardId: coupCardId
      };
      postRequest('/haoban-app-customer-web/inner/del-card-coup', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('删除成功', 'success');
            that.getTableList();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 编辑卡券
     */
    toEdit(index, row) {
      const that = this;
      that.$router.push(`/newCard?coupCardId=${row.coupCardId}`);
    },
    /**
     * 输入
     */
    toInput: _debounce(function(e, value) {
      const that = this;
      that.currentPage = 1;
      that.getTableList();
    }, 500),
    // 搜索清除
    clearInput() {
      const that = this;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 新建卡券
     */
    toNewCard() {
      const that = this;
      that.$router.push(`/newCard`);
    },
    /**
     * 分页---页码变化
     */
    handleSizeChange(val) {
      let that = this;
      that.pageSize = val;
      that.getTableList();
    },

    /**
     * 分页---当前页变化
     */
    handleCurrentChange(val) {
      let that = this;
      that.currentPage = val;
      that.getTableList();
    },
    /**
     * 切换年
     */
    changeYear() {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 获取列表数据
     */
    async getTableList() {
      const that = this;
      let para = {
        wxEnterpriseId: that.wxEnterpriseId,
        getDateRange: that.conditionObj.getDateRange || '', // 搜索字段
        useDateRange: that.conditionObj.useDateRange || '', // 搜索字段
        search: that.conditionObj.searchInput || '', // 搜索字段
        pageNum: that.currentPage, // 当前页
        pageSize: that.pageSize // 一页显示个数
      };
      postRequest('/haoban-app-customer-web/inner/find-card-page', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            that.tableData = resData.result.list || [];
            that.total = resData.result.pageInfo.total;
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },
  mounted() {
    let that = this;
    that.$emit('showTab', '42');
    that.getTableList();
  }
};
</script>
<style type="text/less" lang="less" scoped>
.w-123 {
  width: 123px;
}
.p-20 {
  padding: 20px;
  box-sizing: border-box;
}
</style>
